//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TRawDataFile::TRawDataFile(AnsiString FileName)
   : TPersistent()
{
   InitialInternalFile();//default File, make F<>NULL
   LoadFromFile(FileName);
}
//---------------------------------------------------------------------------
__fastcall TRawDataFile::~TRawDataFile(void)
{
   delete F;
}
//---------------------------------------------------------------------------
void __fastcall TRawDataFile::InitialInternalFile()
{
   if(F) delete F;//Close previous open file
   F = new TFileStream("TEMP.DAT", fmCreate);
   FDataCount = 0;
   FFieldCount = 0;
}
//---------------------------------------------------------------------------
int __fastcall TRawDataFile::GetData(int Index, int FieldNo)
{
   int ret = -MaxInt;//Error Data
   if(Index>-1&&Index<FDataCount&&FieldNo>-1&&FieldNo<FFieldCount){
      int FieldSize = sizeof(int);
      int RecSize = FieldSize * FFieldCount;
      F->Position = RecSize * Index + FieldSize * FieldNo;
      F->Read(&ret, FieldSize);
   }
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall TRawDataFile::CountingFields(AnsiString S)
{
   int ret = 0;
   S = S.Trim();
   if(S!=""){
      if(S[S.Length()]!=',') S = S + ",";
      for(int i=1; i<=S.Length(); i++)
         if(S[i]==',') ret++;
   }
   return ret;
}
//---------------------------------------------------------------------------
void __fastcall TRawDataFile::LoadFromFile(AnsiString FileName)
{
   if(FileExists(FileName)){
      InitialInternalFile();
      TStringList *M = new TStringList();
      try{
         TStringList *L = new TStringList();
         try{
            L->LoadFromFile(FileName);
            if(L->Count > 0){                               //ɮצܤ֦@DƭȪ,
               //Counting and Adjust Input Data----------------------------------
               FDataCount = L->Count-1;                     //Ĥ@DƭȪ.
               FFieldCount = CountingFields(L->Strings[0]); //ѲĤ@ƭp FieldCount.
               L->Delete(0);                                //N @Ʋ.
               //----------------------------------------------------------------
               M->CommaText = L->Text;
            }
         }
         __finally{
            delete L;
         }

         for(int i=0; i<M->Count; i++){
            int V = StrToInt(M->Strings[i].Trim());
            F->Write(&V, sizeof(V));
         }
      }
      __finally{
         delete M;
      }
   }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   ListBox1->Clear();
   TRawDataFile *F = new TRawDataFile("TEST.TXT");
   try{
      ListBox1->Items->Add("DataCount=" + IntToStr(F->DataCount));
      ListBox1->Items->Add("FieldCount=" + IntToStr(F->FieldCount));
      ListBox1->Items->Add("");

      AnsiString S;
      for(int i=0; i<F->DataCount; i++){
         S.sprintf("Data[%d][%d]=%d", i,0,F->Data[i][0]);
         ListBox1->Items->Add(S);
      }
   }
   __finally{
      delete F;
   }
}
//---------------------------------------------------------------------------
